//  gulp
const gulp = require('gulp');
//  js丑化
const uglify = require('gulp-uglify');
//  文件合并
const concat = require('gulp-concat');
//  less编译
const less = require('gulp-less');
//  压缩CSS为一行
const cleanCSS = require('gulp-clean-css');
//  浏览器兼容
const autoprefixer = require('gulp-autoprefixer');
//  删除模块
const del = require('del')
const changed = require('gulp-changed'); //检查改变状态 
//  监听文件变化
const connect = require('gulp-connect');
//  debug，命令行打印
const debug = require('gulp-debug');
const open = require('open');          // 打开服务器
const minCSS = require('gulp-minify-css');

var src = './';
var dist = src;
var lessp = 'less/*.less';
var js = 'js/*.js';
var html = '*.html';
var images = 'images/*';
var lib = 'lib/*.min.js';
var iconfont = 'iconfont/*';

/**
 * less
 */
gulp.task('less', function () {
    console.info("正在观察less文件变动");
    gulp.src([src + lessp])                    //多个文件以数组形式传入
        .pipe(less())                          //编译less文件  
        .pipe(concat('base.min.css'))           //合并之后生成bus.css  
        //.pipe(autoprefixer())                   // 自动补全兼容
        .pipe(minCSS())
        .pipe(cleanCSS())                      //压缩新生成的css
        .pipe(gulp.dest(dist + 'css'))	       //将会在dist/css下生成bus.css
        .pipe(connect.reload())
        .pipe(debug({ title: 'LESS：' }))
});

//js  
gulp.task("js", function () {
    console.info("正在观察js文件变动");
    gulp.src([src + js, '!' + src + 'js/*.min.js'])
        .pipe(concat('base.min.js'))
        .pipe(uglify())
        .pipe(gulp.dest(dist + 'js'))
        .pipe(connect.reload())
        .pipe(debug({ title: 'JS：' }))
});

// html
gulp.task("html", function () {
    console.info("正在观察html文件变动");
    gulp.src([src + html])
        // .pipe(gulp.dest(dist))
        .pipe(connect.reload())
        .pipe(debug({ title: 'HTML' }))
});

// images
// gulp.task("images",function(){  
//     gulp.src([src + images])
//         .pipe(gulp.dest(dist + 'images/'))
//         .pipe(connect.reload())
//         .pipe(debug({title: 'IMG：'}))
// });

// lib
// gulp.task("lib",function(){  
//     gulp.src([src + lib])
//         .pipe(gulp.dest(dist + 'js'))
//         .pipe(connect.reload())
//         .pipe(debug({title: 'LIB：'}))
// });

// iconfont
// gulp.task("iconfont",function(){  
//     gulp.src([src + iconfont])
//         .pipe(gulp.dest(dist + 'iconfont'))
//         .pipe(connect.reload())
//         .pipe(debug({title: 'ICF：'}))
// });

gulp.task('build', ['less', 'js', 'html']);

//  server任务，负责监听文件的改变并且编译
gulp.task('server', ['build'], () => {
    connect.server({
        livereload: true,       // 热更新，文件改变会自动重新编译
        port: 2017
    });

    // 需要监听的任务
    gulp.watch(src + lessp, ['less']);
    gulp.watch(src + js, ['js']);
    gulp.watch(src + html, ['html']);
    // gulp.watch(src + images, ['images']);
    // gulp.watch(src + lib, ['lib']);
});

gulp.task('default', ['server']);
